@echo off

title R4S Firmware Download

cls
echo *********************************
echo **                             **
echo **    R4S Firmware Download    **
echo **                             **
echo **       (C) R4S R^&D           **
echo **                             **
echo *********************************
echo.

rem -- default JLink path
set jlink_path=C:\Program Files (x86)\SEGGER\JLink_V492\
rem -- default log file
set log=log.csv

rem -- script for JLink
set jlink_file_script_filename=RK-G200S-E_v4_11.txt
rem -- model name
set MODEL=RK-G200S-E
rem -- version major
set VER_MAJOR=4
rem -- version minor
set VER_MINOR=11
rem -- device family
set DEV_FAMILY=NRF51822

rem -- main program
set jlink_file_script=%jlink_file_script_filename%
set jlink_cmd=jlink.exe -device %DEV_FAMILY% -if SWD -speed 1000 -CommanderScript %jlink_file_script%
set cmd='%jlink_cmd%'

if not exist "%~dp0\r4s_download.ini" goto jlink_check

for /F "tokens=1,2 delims==" %%A in (%~dp0\r4s_download.ini) do (
	if "%%A"=="jlink_path" set jlink_path=%%B
	if "%%A"=="logfile" set LOG=%%B
)

set PATH=%PATH%;%jlink_path%;

:jlink_check
if exist "%jlink_path%jlink.exe" goto program

echo Error: JLink.exe is not found.
echo.
pause
goto end

:program
set cmdcnt=0
for /F "tokens=1,2,3,4,5,6,7,8,9,10" %%A in (%cmd%) do (
	if "%%A"=="1000005C" (
		set "CONFIGID=%%C%%D%%E%%F"
		set /a cmdcnt=cmdcnt+1
	)
	if "%%A"=="10000060" (
		set "DEVICEID=%%C%%D%%E%%F%%G%%H%%I%%J"
		set /a cmdcnt=cmdcnt+1
	)
	if "%%A"=="100000A4" (
		set "DEVICEADDR=%%C%%D%%E%%F%%G%%H%%I%%J"
		set /a cmdcnt=cmdcnt+1
	)
)
if %cmdcnt%==3 (
	setlocal EnableDelayedExpansion
	echo %MODEL%;%VER_MAJOR%;%VER_MINOR%;%DATE%;%TIME%;!CONFIGID!;!DEVICEID!;!DEVICEADDR! >> %LOG%
	endlocal
	goto end
)

echo Error: Device is not found.
echo.
pause

:end
